﻿/*======================================================================*//**
* 
* jp.nium Classes
* 
* @author		Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* @version		2.0.22
* @see			http://www.libspark.org/
* 
* Project Manager
* taka:nium		http://nium.jp/
* 
* Hosted by
* Spark project	http://www.libspark.org/
* 
* Licensed under the MIT License
* 
* Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
* 
*/
package jp.nium.core.collections {
	import flash.utils.Dictionary;
	import jp.nium.core.namespaces.nium_internal;
	import jp.nium.display.IExDisplayObject;
	
	use namespace nium_internal;
	
	/*======================================================================*//**
	* @private
	*/
	public class DisplayList {
		
		/*======================================================================*//**
		* @private
		*/
		private static var _instanceList		:Dictionary = new Dictionary( true );
		
		/*======================================================================*//**
		* @private
		*/
		private static var _idList				:Dictionary = new Dictionary( true );
		
		
		
		
		
		/*======================================================================*//**
		* @private
		*/
		public function DisplayList() {
			throw new ArgumentError( "Error #2012: DisplayList クラスを直接インスタンス化することはできません。" );
		}
		
		
		
		
		
		/*======================================================================*//**
		* @private
		*/
		nium_internal static function addInstance( instance:IExDisplayObject, id:String ):IExDisplayObject {
			// 既存の設定を削除する
			nium_internal::removeInstance( instance );
			
			// 新しく登録する
			_instanceList[id] = instance;
			_idList[instance] = id;
			
			return IExDisplayObject( instance );
		}
		
		/*======================================================================*//**
		* @private
		*/
		nium_internal static function removeInstance( instance:IExDisplayObject ):IExDisplayObject {
			delete _instanceList[instance.id];
			delete _idList[instance];
			
			return IExDisplayObject( instance );
		}
		
		/*======================================================================*//**
		* @private
		*/
		nium_internal static function removeInstanceById( id:String ):IExDisplayObject {
			return nium_internal::removeInstance( _instanceList[id] );
		}
		
		/*======================================================================*//**
		* @private
		*/
		nium_internal static function getIdByInstance( instance:IExDisplayObject ):String {
			return _idList[instance];
		}
		
		/*======================================================================*//**
		* @private
		*/
		nium_internal static function getInstanceById( id:String ):IExDisplayObject {
			return _instanceList[id];
		}
	}
}





