﻿/*======================================================================*//**
* 
* jp.nium Classes
* 
* @author		Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* @version		2.0.22
* @see			http://www.libspark.org/
* 
* Project Manager
* taka:nium		http://nium.jp/
* 
* Hosted by
* Spark project	http://www.libspark.org/
* 
* Licensed under the MIT License
* 
* Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
* 
*/
package jp.nium.display {
	import flash.display.LoaderInfo;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.errors.IllegalOperationError;
	import flash.events.Event;
	import flash.events.HTTPStatusEvent;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.net.URLRequest;
	import flash.ui.ContextMenu;
	import jp.nium.display.DocumentRoot;
	import jp.nium.events.DocumentEvent;
	
	/*======================================================================*//**
	* ロード操作が開始したときに送出されます。
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @eventType flash.events.Event.OPEN
	*/
	[Event( name="open", type="flash.events.Event" )]
	
	/*======================================================================*//**
	* ロードされた SWF ファイルのプロパティおよびメソッドにアクセスできる場合に送出されます。
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @eventType flash.events.Event.INIT
	*/
	[Event( name="init", type="flash.events.Event" )]
	
	/*======================================================================*//**
	* データが正常にロードされたときに送出されます。
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @eventType flash.events.Event.COMPLETE
	*/
	[Event( name="complete", type="flash.events.Event" )]
	
	/*======================================================================*//**
	* ロードされたオブジェクトが Loader オブジェクトの unload() メソッドを使用して削除されるたびに、LoaderInfo オブジェクトによって送出されます。
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @eventType flash.events.Event.UNLOAD
	*/
	[Event( name="unload", type="flash.events.Event" )]
	
	/*======================================================================*//**
	* ダウンロード処理を実行中にデータを受信したときに送出されます。
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @eventType flash.events.ProgressEvent.PROGRESS
	*/
	[Event( name="progress", type="flash.events.ProgressEvent" )]
	
	/*======================================================================*//**
	* 入出力エラーが発生してロード処理が失敗したときに送出されます。
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @eventType flash.events.IOErrorEvent.IO_ERROR
	*/
	[Event( name="ioError", type="flash.events.IOErrorEvent" )]
	
	/*======================================================================*//**
	* 
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @example <listing version="3.0" >
	* </listing>
	*/
	public class ExPreloader extends DocumentRoot {
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get url()					:String { return _url; }
		public function set url( value				:String ):void {
			if ( _opened ) { throw new IllegalOperationError( "すでに読み込み操作が開始されている為、読み込み先 URL の設定は行えません。" ); }
			
			_url = value;
		}
		private var _url							:String = "index.swf";
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get useSWFBasePath()		:Boolean { return _useSWFBasePath; }
		private var _useSWFBasePath					:Boolean = false;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get opened()				:Boolean { return _opened; }
		private var _opened							:Boolean = false;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get actionScriptVersion()	:uint {
			try {
				return _loader.contentLoaderInfo.actionScriptVersion;
			}
			catch ( e:Error ) {}
			
			return 0;
		}
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get bytesLoaded()			:int {
			try {
				return _loader.contentLoaderInfo.bytesLoaded;
			}
			catch ( e:Error ) {}
			
			return 0;
		}
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get bytesTotal()			:int {
			try {
				return _loader.contentLoaderInfo.bytesTotal;
			}
			catch ( e:Error ) {}
			
			return 0;
		}
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get frameRate()				:Number {
			try {
				return _loader.contentLoaderInfo.frameRate;
			}
			catch ( e:Error ) {}
			
			return 0;
		}
		
		/*======================================================================*//**
		* ExPreloader インスタンスが Event.OPEN イベントを受け取った場合に呼び出されるイベントハンドラメソッドを取得または設定します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get onOpen()				:Function { return __onOpen || _onOpen; }
		public function set onOpen( value			:Function ):void { __onOpen = value; }
		private var __onOpen						:Function;
		
		/*======================================================================*//**
		* サブクラスで onOpen イベントハンドラメソッドの処理を override で指定したい場合に上書きします。
		* このメソッドは、onOpen プロパティに別のメソッドを指定された場合、無効化されます。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @see	#onOpen
		*/
		protected function _onOpen()					:void {}
		
		/*======================================================================*//**
		* ExPreloader インスタンスが Event.COMPLETE イベントを受け取った場合に呼び出されるイベントハンドラメソッドを取得または設定します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get onComplete()			:Function { return __onComplete || _onComplete; }
		public function set onComplete( value		:Function ):void { __onComplete = value; }
		private var __onComplete					:Function;
		
		/*======================================================================*//**
		* サブクラスで onComplete イベントハンドラメソッドの処理を override で指定したい場合に上書きします。
		* このメソッドは、onComplete プロパティに別のメソッドを指定された場合、無効化されます。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @see	#onComplete
		*/
		protected function _onComplete()			:void {}
		
		/*======================================================================*//**
		* ExPreloader インスタンスが ProgressEvent.PROGRESS イベントを受け取った場合に呼び出されるイベントハンドラメソッドを取得または設定します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get onProgress()			:Function { return __onProgress || _onProgress; }
		public function set onProgress( value		:Function ):void { __onProgress = value; }
		private var __onProgress					:Function;
		
		/*======================================================================*//**
		* サブクラスで onProgress イベントハンドラメソッドの処理を override で指定したい場合に上書きします。
		* このメソッドは、onProgress プロパティに別のメソッドを指定された場合、無効化されます。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @see	#onProgress
		*/
		protected function _onProgress()			:void {}
		
		/*======================================================================*//**
		* ExPreloader インスタンスが ProgressEvent.PROGRESS イベントを受け取った場合に呼び出されるイベントハンドラメソッドを取得または設定します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get onIOError()				:Function { return __onIOError || _onIOError; }
		public function set onIOError( value		:Function ):void { __onIOError = value; }
		private var __onIOError						:Function;
		
		/*======================================================================*//**
		* サブクラスで onIOError イベントハンドラメソッドの処理を override で指定したい場合に上書きします。
		* このメソッドは、onIOError プロパティに別のメソッドを指定された場合、無効化されます。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @see	#onIOError
		*/
		protected function _onIOError()				:void {}
		
		/*======================================================================*//**
		* ExLoader インスタンスを取得します。 
		*/
		private var _loader							:ExLoader;
		
		
		
		
		
		/*======================================================================*//**
		* 新しい Preloader インスタンスを作成します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function ExPreloader() {
			// stage の初期設定を行います。
			align = StageAlign.TOP_LEFT;
			scaleMode = StageScaleMode.NO_SCALE;
			
			// ContextMenu を初期化する
			contextMenu = new ContextMenu();
			contextMenu.hideBuiltInItems();
			
			// イベントリスナーを登録する
			addExclusivelyEventListener( DocumentEvent.INIT, _init, false, int.MAX_VALUE, true );
		}
		
		
		
		
		
		/*======================================================================*//**
		* SWF ファイルの読み込みが完了した場合に送出されます。
		*/
		private function _init( e:DocumentEvent ):void {
			// flashvars からファイルパスを取得する
			_url = loaderInfo.parameters.url || _url;
			_useSWFBasePath = loaderInfo.parameters.useSWFBasePath || _useSWFBasePath;
			
			// 読み込むファイルの基点を設定する
			var url:String = _useSWFBasePath ? DocumentRoot.toDocumentBasePath( _url ) : _url;
			
			// Loader を作成する
			_loader = ExLoader( addChild( new ExLoader() ) );
            _loader.contentLoaderInfo.addEventListener( Event.OPEN, _open, false, int.MAX_VALUE, true );
			_loader.contentLoaderInfo.addEventListener( Event.COMPLETE, _complete, false, int.MAX_VALUE, true );
            _loader.contentLoaderInfo.addEventListener( Event.UNLOAD, _unload, false, int.MAX_VALUE, true );
            _loader.contentLoaderInfo.addEventListener( ProgressEvent.PROGRESS, _progress, false, int.MAX_VALUE, true );
            _loader.contentLoaderInfo.addEventListener( HTTPStatusEvent.HTTP_STATUS, _httpStatus, false, int.MAX_VALUE, true );
            _loader.contentLoaderInfo.addEventListener( IOErrorEvent.IO_ERROR, _ioError, false, int.MAX_VALUE, true );
			_loader.load( new URLRequest( url ) );
		}
		
		/*======================================================================*//**
		* ロード操作が開始したときに送出されます。
		*/
		private function _open( e:Event ):void {
			// 読み込み処理を開始する
			_opened = true;
			
			// イベントを送出する
			dispatchEvent( e );
			
			// イベントハンドラメソッドを実行する
			onOpen();
		}
		
		/*======================================================================*//**
		* データが正常にロードされたときに送出されます。
		*/
		private function _complete( e:Event ):void {
			// イベントを送出する
			dispatchEvent( e );
			
			// イベントハンドラメソッドを実行する
			onComplete();
		}
		
		/*======================================================================*//**
		* ロードされたオブジェクトが Loader オブジェクトの unload() メソッドを使用して削除されるたびに、LoaderInfo オブジェクトによって送出されます。
		*/
		private function _unload( e:Event ):void {
			// イベントを送出する
			dispatchEvent( e );
		}
		
		/*======================================================================*//**
		* ダウンロード処理を実行中にデータを受信したときに送出されます。
		*/
		private function _progress( e:ProgressEvent ):void {
			// イベントを送出する
			dispatchEvent( e );
			
			// イベントハンドラメソッドを実行する
			onProgress();
		}
		
		/*======================================================================*//**
		* ネットワーク要求が HTTP を介して行われ、Flash Player が HTTP 状況コードを検出できる場合に送出されます。
		*/
		private function _httpStatus( e:HTTPStatusEvent ):void {
			// イベントを送出する
			dispatchEvent( e );
		}
		
		/*======================================================================*//**
		* 入出力エラーが発生してロード処理が失敗したときに送出されます。
		*/
		private function _ioError( e:IOErrorEvent ):void {
			// イベントを送出する
			dispatchEvent( e );
			
			// イベントハンドラメソッドを実行する
			onIOError();
		}
	}
}








