﻿/*======================================================================*//**
* 
* jp.nium Classes
* 
* @author		Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* @version		2.0.22
* @see			http://www.libspark.org/
* 
* Project Manager
* taka:nium		http://nium.jp/
* 
* Hosted by
* Spark project	http://www.libspark.org/
* 
* Licensed under the MIT License
* 
* Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
* 
*/
package jp.nium.display {
	import flash.display.DisplayObject;
	import flash.geom.Rectangle;
	import jp.nium.display.IExDisplayObject;
	
	/*======================================================================*//**
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	*/
	public interface IExDisplayObjectContainer extends IExDisplayObject {
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#numChildren
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function get numChildren()		:int;
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#children
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function get children()			:Array;
		
		
		
		
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#addChild()
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function addChild( child:DisplayObject ):DisplayObject;
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#addChildAt()
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function addChildAt( child:DisplayObject, index:int ):DisplayObject;
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#addChildAt()
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function addChildAtAbove( child:DisplayObject, index:int, addAbove:Boolean = true ):DisplayObject;
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#removeChild()
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function removeChild( child:DisplayObject ):DisplayObject;
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#removeChildAt()
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function removeChildAt( index:int ):DisplayObject;
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#removeAllChildren()
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function removeAllChildren():void;
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#contains()
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function contains( child:DisplayObject ):Boolean;
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#getChildAt()
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function getChildAt( index:int ):DisplayObject;
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#getChildByName()
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function getChildByName( name:String ):DisplayObject;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function getChildrenByClass( className:Class ):Array;
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#getChildIndex()
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function getChildIndex( child:DisplayObject ):int;
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#setChildIndex()
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function setChildIndex( child:DisplayObject, index:int ):void;
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#setChildIndexAbove()
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function setChildIndexAbove( child:DisplayObject, index:int, addAbove:Boolean = true ):void;
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#swapChildren()
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function swapChildren( child1:DisplayObject, child2:DisplayObject ):void;
		
		/*======================================================================*//**
		* @copy jp.nium.display.ChildIndexer#swapChildrenAt()
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function swapChildrenAt( index1:int, index2:int ):void;
		
		/*======================================================================*//**
		* @private
		*/
		function startDrag( lockCenter:Boolean = false, bounds:Rectangle = null ):void;
		
		/*======================================================================*//**
		* @private
		*/
		function stopDrag():void;
	}
}





