﻿/*======================================================================*//**
* 
* jp.nium Classes
* 
* @author		Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* @version		2.0.22
* @see			http://www.libspark.org/
* 
* Project Manager
* taka:nium		http://nium.jp/
* 
* Hosted by
* Spark project	http://www.libspark.org/
* 
* Licensed under the MIT License
* 
* Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
* 
*/
package jp.nium.events {
	import flash.display.Stage;
	import flash.events.Event;
	import jp.nium.display.DocumentRoot;
	
	/*======================================================================*//**
	* 
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @example <listing version="3.0" >
	* </listing>
	*/
	public class DocumentEvent extends Event {
		
		/*======================================================================*//**
		* init イベントオブジェクトの type プロパティ値を定義します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public static const INIT				:String = "init";
		
		/*======================================================================*//**
		* resizeStart イベントオブジェクトの type プロパティ値を定義します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public static const RESIZE_START		:String = "resizeStart";
		
		/*======================================================================*//**
		* resizeProgress イベントオブジェクトの type プロパティ値を定義します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public static const RESIZE_PROGRESS		:String = "resizeProgress";
		
		/*======================================================================*//**
		* resizeComplete イベントオブジェクトの type プロパティ値を定義します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public static const RESIZE_COMPLETE		:String = "resizeComplete";
		
		
		
		
		
		/*======================================================================*//**
		* @copy jp.nium.display.DocumentRoot#root
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get root()				:DocumentRoot { return _root; }
		private var _root						:DocumentRoot;
		
		/*======================================================================*//**
		* @copy jp.nium.display.DocumentRoot#stage
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get stage()				:Stage { return _stage; }
		private var _stage						:Stage;
		
		/*======================================================================*//**
		* @copy jp.nium.display.DocumentRoot#stageWidth
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get stageWidth()		:int { return _stageWidth; }
		private var _stageWidth					:int = 0;
		
		/*======================================================================*//**
		* @copy jp.nium.display.DocumentRoot#stageHeight
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get stageHeight()		:int { return _stageHeight; }
		private var _stageHeight				:int = 0;
		
		
		
		
		
		/*======================================================================*//**
		* 新しい DocumentEvent インスタンスを作成します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @param	type		説明文
		* @param	bubbles		説明文
		* @param	cancelable	説明文
		* @param	root		説明文
		*/
		public function DocumentEvent( type:String, bubbles:Boolean = false, cancelable:Boolean = false, root:DocumentRoot = null ) {
			super( type, bubbles, cancelable );
			
			_root = root;
			_stage = root.stage;
			_stageWidth = stage.stageWidth;
			_stageHeight = stage.stageHeight;
		}
		
		
		
		
		
		/*======================================================================*//**
		* DocumentEvent インスタンスのコピーを作成して、各プロパティの値を元のプロパティの値と一致するように設定します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @return	元のオブジェクトと同じプロパティ値を含む新しい DocumentEvent インスタンスです。
		*/
		public override function clone():Event {
			return new DocumentEvent( type, bubbles, cancelable, root );
		}
		
		/*======================================================================*//**
		* 指定されたオブジェクトのストリング表現を返します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @return	オブジェクトのストリング表現です。
		*/
		public override function toString():String {
			return formatToString( "DocumentEvent", "type", "bubbles", "cancelable", "root" );
		}
	}
}





