﻿/*======================================================================*//**
* 
* jp.nium Classes
* 
* @author		Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* @version		2.0.22
* @see			http://www.libspark.org/
* 
* Project Manager
* taka:nium		http://nium.jp/
* 
* Hosted by
* Spark project	http://www.libspark.org/
* 
* Licensed under the MIT License
* 
* Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
* 
*/
package jp.nium.graphics {
	import jp.nium.core.namespaces.nium_internal;
	import jp.nium.core.graphics.GraphicObject;
	
	use namespace nium_internal;
	
	/*======================================================================*//**
	* 
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @example <listing version="3.0" >
	* </listing>
	*/
	public class Gear extends GraphicObject {
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get radiusMin()					:Number { return _radiusMin; }
		public function set radiusMin( value			:Number ):void {
			_radiusMin = value;
			_draw();
		}
		private var _radiusMin							:Number = 45;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get radiusMax()					:Number { return _radiusMax; }
		public function set radiusMax( value			:Number ):void {
			_radiusMax = value;
			_draw();
		}
		private var _radiusMax							:Number = 50;
		
		
		
		
		
		/*======================================================================*//**
		* 新しい Gear インスタンスを作成します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function Gear() {
		}
		
		
		
		
		
		/*======================================================================*//**
		* @private
		*/
		protected override function _draw():void {
			nium_internal::graphics.clear();
			
			nium_internal::graphics.beginFill( fillColor, 1 );
			if ( lineWidth >= 0  ) {
				nium_internal::graphics.lineStyle( lineWidth, lineColor, 1 );
			}
			nium_internal::graphics.moveTo( radiusMax, 0 );
			var l:int = 361;
			for ( var i:int = 0; i < l; i++ ) {
				var radius:Number = Math.floor( i / 18 ) % 2 ? radiusMax : radiusMin;
				var r:Number = Math.PI * i / 180;
				nium_internal::graphics.lineTo( Math.sin( r ) * radius + radiusMax, Math.cos( r ) * radius + radiusMax );
			}
			nium_internal::graphics.endFill();
		}
		
		/*======================================================================*//**
		* 指定されたオブジェクトのストリング表現を返します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @return	オブジェクトのストリング表現です。
		*/
		public override function toString():String {
			return "[object Gear]";
		}
	}
}





