﻿/*======================================================================*//**
* 
* jp.nium Classes
* 
* @author		Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* @version		2.0.22
* @see			http://www.libspark.org/
* 
* Project Manager
* taka:nium		http://nium.jp/
* 
* Hosted by
* Spark project	http://www.libspark.org/
* 
* Licensed under the MIT License
* 
* Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
* 
*/
package jp.nium.lang {
	import flash.system.Capabilities;
	import flash.utils.Dictionary;
	import jp.nium.events.EventIntegrator;
	
	/*======================================================================*//**
	* Locale クラスを直接インスタンス化することはできません。
	* new Locale() コンストラクタを呼び出すと、ArgumentError 例外がスローされます。
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @example <listing version="3.0" >
	* </listing>
	*/
	public class Locale {
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public static function get enabled()			:Boolean { return _enabled; }
		private static var _enabled						:Boolean = function():Boolean {
			// EventIntegrator を作成する
			_integrator = new EventIntegrator();
			
			// 初期言語を設定する
			language = Capabilities.language;
			
			return true;
		}.apply();
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public static function get language()			:String { return _language; }
		public static function set language( value		:String ):void { _language = value; }
		private static var _language					:String;
		
		/*======================================================================*//**
		* @private
		*/
		private static var _defaultLanguage				:String = "en";
		
		/*======================================================================*//**
		* EventIntegrator インスタンスを取得します。
		*/
		private static var _integrator					:EventIntegrator;
		
		/*======================================================================*//**
		* EventIntegrator インスタンスを取得します。
		*/
		private static var _dictionary					:Dictionary = new Dictionary();
		
		
		
		
		
		/*======================================================================*//**
		* @private
		*/
		public function Locale() {
			throw new ArgumentError( "Error #2012: Locale クラスを直接インスタンス化することはできません。" );
		}
		
		
		
		
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @param	id		説明文
		* @return			説明文
		*/
		public static function getString( id:String ):String {
			return getStringByLang( id, language );
		}
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @param	id		説明文
		* @param	lang	説明文
		* @return			説明文
		*/
		public static function getStringByLang( id:String, lang:String = null ):String {
			if ( !lang ) {
				lang = language;
			}
			
			if ( _dictionary[lang] ) { return _dictionary[lang][id]; }
			return _dictionary[_defaultLanguage][id];
		}
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @param	id		説明文
		* @param	lang	説明文
		* @param	value	説明文
		*/
		public static function setString( id:String, lang:String, value:String ):void {
			// 初期化されていなければ初期化する
			if ( !_dictionary[lang] ) {
				_dictionary[lang] = new Dictionary();
			}
			
			// 設定する
			_dictionary[lang][id] = value;
		}
	}
}














