﻿/*======================================================================*//**
* 
* Progression Framework
* 
* @author		Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* @version		2.0.22
* @see			http://progression.jp/
* @see			http://progression.libspark.org/
* 
* Project Manager
* taka:nium		http://nium.jp/
* 
* Hosted by
* Spark project	http://www.libspark.org/
* 
* Supported by
* yossy			http://www.be-interactive.org/
* cellfusion	http://cellfusion.jp/
* rch850		http://850mb.net/
* nobu			http://humming.via-kitchen.com/
* trick7		http://www.trick7.com/
* minaco		http://minaco.net/
* ksakai		http://www.onflow.jp/blog/
* 
* Licensed under the MIT License
* 
* Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
* 
*/
package jp.progression.casts {
	import flash.ui.ContextMenu;
	import jp.nium.display.IExDisplayObject;
	
	/*======================================================================*//**
	* 
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @example <listing version="3.0" >
	* </listing>
	*/
	public interface ICastObject extends IExDisplayObject {
		
		/*======================================================================*//**
		* このキャストオブジェクトの子に設定されているキャストオブジェクトの参照配列を取得します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function get casts()					:Array;
		
		/*======================================================================*//**
		* このオブジェクトに関連付けられたコンテキストメニューを取得または設定します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function get contextMenu()				:ContextMenu;
		function set contextMenu( value			:ContextMenu ):void;
		
		/*======================================================================*//**
		* addCommand() メソッドで追加した Command インスタンスの実行方法を並列処理にするかどうかを取得または設定します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function get parallelMode()				:Boolean;
		function set parallelMode( value		:Boolean ):void;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function get extra()					:Object;
		function set extra( extra				:Object ):void;
		
		/*======================================================================*//**
		* キャストオブジェクトが CastEvent.CAST_ADDED イベントを受け取った場合に呼び出されるイベントハンドラメソッドを取得または設定します。
		* このイベントハンドラメソッド実行中には、addCommand() メソッドによるコマンドの同期処理が行えます。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function get onCastAdded()				:Function;
		function set onCastAdded( value			:Function ):void;
		
		/*======================================================================*//**
		* キャストオブジェクトが CastEvent.CAST_REMOVED イベントを受け取った場合に呼び出されるイベントハンドラメソッドを取得または設定します。
		* このイベントハンドラメソッド実行中には、addCommand() メソッドによるコマンドの同期処理が行えます。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function get onCastRemoved()			:Function;
		function set onCastRemoved( value		:Function ):void;
		
		/*======================================================================*//**
		* キャストオブジェクトが CastEvent.CAST_STATE_CHANGE イベントを受け取った場合に呼び出されるイベントハンドラメソッドを取得または設定します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function get onCastStateChange()		:Function;
		function set onCastStateChange( value	:Function ):void;
		
		
		
		
		
		/*======================================================================*//**
		* 特定のイベントが送出された際に実行したい Command インスタンスを追加します。
		* Command インスタンスは、イベントが送出される直前に自動的にクリアされ、送出後に自動的に処理されます。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @param	commands	追加したいコマンド配列です。
		*/
		function addCommand( ... commands:Array ):void;
		
		/*======================================================================*//**
		* addCommand() メソッドで追加された Command インスタンスをクリアします。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		function clearCommand():void;
	}
}





