﻿/*======================================================================*//**
* 
* Progression Framework
* 
* @author		Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* @version		2.0.22
* @see			http://progression.jp/
* @see			http://progression.libspark.org/
* 
* Project Manager
* taka:nium		http://nium.jp/
* 
* Hosted by
* Spark project	http://www.libspark.org/
* 
* Supported by
* yossy			http://www.be-interactive.org/
* cellfusion	http://cellfusion.jp/
* rch850		http://850mb.net/
* nobu			http://humming.via-kitchen.com/
* trick7		http://www.trick7.com/
* minaco		http://minaco.net/
* ksakai		http://www.onflow.jp/blog/
* 
* Licensed under the MIT License
* 
* Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
* 
*/
package jp.progression.casts.presets {
	import caurina.transitions.Equations;
	import flash.display.MovieClip;
	import jp.nium.utils.MathUtil;
	import jp.progression.casts.CastMovieClip;
	import jp.progression.commands.DoTweener;
	import jp.progression.events.CastEvent;
	
	/*======================================================================*//**
	* 
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @example <listing version="3.0" >
	* </listing>
	*/
	public class FadeMovie extends CastMovieClip {
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get direction()					:String { return _direction; }
		public function set direction( value			:String ):void {
			// タイプによって振り分ける
			switch ( value ) {
				case FadeMovieDirectionType.IN		:
				case FadeMovieDirectionType.IN_OUT	:
				case FadeMovieDirectionType.OUT		: { _direction = value; break; }
			}
		}
		private var _direction							:String = FadeMovieDirectionType.IN_OUT;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get duration()					:int { return _duration; }
		public function set duration( value				:int ):void { _duration = Math.max( 0, value ); }
		private var _duration							:int = 1000;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get alphaMultiplier()			:int { return _alphaMultiplier; }
		public function set alphaMultiplier( value		:int ):void { _alphaMultiplier = MathUtil.range( value, 0, 1 ); }
		private var _alphaMultiplier					:int = 0;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get alphaOffset()				:int { return _alphaOffset; }
		public function set alphaOffset( value			:int ):void { _alphaOffset = MathUtil.range( value, -255, 255); }
		private var _alphaOffset						:int = 0;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get blueMultiplier()			:int { return _blueMultiplier; }
		public function set blueMultiplier( value		:int ):void { _blueMultiplier = MathUtil.range( value, 0, 1 ); }
		private var _blueMultiplier						:int = 1;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get blueOffset()				:int { return _blueOffset; }
		public function set blueOffset( value			:int ):void { _blueOffset = MathUtil.range( value, -255, 255 ); }
		private var _blueOffset							:int = 0;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get greenMultiplier()			:int { return _greenMultiplier; }
		public function set greenMultiplier( value		:int ):void { _greenMultiplier = MathUtil.range( value, 0, 1 ); }
		private var _greenMultiplier					:int = 1;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get greenOffset()				:int { return _greenOffset; }
		public function set greenOffset( value			:int ):void { _greenOffset = MathUtil.range( value, -255, 255 ); }
		private var _greenOffset						:int = 0;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get redMultiplier()				:int { return _redMultiplier; }
		public function set redMultiplier( value		:int ):void { _redMultiplier = MathUtil.range( value, 0, 1 ); }
		private var _redMultiplier						:int = 1;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get redOffset()					:int { return _redOffset; }
		public function set redOffset( value			:int ):void { _redOffset = MathUtil.range( value, -255, 255 ); }
		private var _redOffset							:int = 0;
		
		/*======================================================================*//**
		* @private
		*/
		protected var _target							:MovieClip;
		
		
		
		
		
		/*======================================================================*//**
		* 新しい FadeMovie インスタンスを作成します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function FadeMovie() {
			// 初期化する
			_target = this;
			
			// 再生を停止する
			stop();
			
			// イベントリスナーを登録する
			addExclusivelyEventListener( CastEvent.CAST_ADDED, _castAdded, false, int.MAX_VALUE, true );
			addExclusivelyEventListener( CastEvent.CAST_REMOVED, _castRemoved, false, int.MAX_VALUE, true );
		}
		
		
		
		
		
		/*======================================================================*//**
		* 指定されたオブジェクトのストリング表現を返します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @return	オブジェクトのストリング表現です。
		*/
		public override function toString():String {
			return "[object FadeMovie : " + ( id || name ) + "]";
		}
		
		
		
		
		
		/*======================================================================*//**
		* キャストオブジェクトが AddChild コマンド経由でディスプレイリストに追加された場合に送出されます。
		*/
		private function _castAdded( e:CastEvent ):void {
			// タイプによって振り分ける
			switch ( _direction ) {
				case FadeMovieDirectionType.IN		:
				case FadeMovieDirectionType.IN_OUT	: {
					// コマンドを追加する
					addCommand( new DoTweener( _target, {
						_color_ra	:redMultiplier,
						_color_rb	:redOffset,
						_color_ga	:greenMultiplier,
						_color_gb	:greenOffset,
						_color_ba	:blueMultiplier,
						_color_bb	:blueOffset,
						_color_aa	:alphaMultiplier,
						_color_ab	:alphaOffset,
						time		:0
					} ) );
					
					// コマンドを追加する
					addCommand( new DoTweener( _target, {
						_color_ra	:1,
						_color_rb	:0,
						_color_ga	:1,
						_color_gb	:0,
						_color_ba	:1,
						_color_bb	:0,
						_color_aa	:1,
						_color_ab	:0,
						time		:duration / 1000,
						transition	:Equations.easeNone
					} ) );
					break;
				}
				case FadeMovieDirectionType.OUT		: {
					// コマンドを追加する
					addCommand( new DoTweener( _target, {
						_color_ra	:1,
						_color_rb	:0,
						_color_ga	:1,
						_color_gb	:0,
						_color_ba	:1,
						_color_bb	:0,
						_color_aa	:1,
						_color_ab	:0,
						time		:0
					} ) );
					break;
				}
			}
		}
		
		/*======================================================================*//**
		* キャストオブジェクトが RemoveChild コマンド経由でディスプレイリストから削除された場合に送出されます。
		*/
		private function _castRemoved( e:CastEvent ):void {
			// タイプによって振り分ける
			switch ( _direction ) {
				case FadeMovieDirectionType.IN		: {
					// コマンドを追加する
					addCommand( new DoTweener( _target, {
						_color_ra	:redMultiplier,
						_color_rb	:redOffset,
						_color_ga	:greenMultiplier,
						_color_gb	:greenOffset,
						_color_ba	:blueMultiplier,
						_color_bb	:blueOffset,
						_color_aa	:alphaMultiplier,
						_color_ab	:alphaOffset,
						time		:0
					} ) );
					break;
				}
				case FadeMovieDirectionType.IN_OUT	:
				case FadeMovieDirectionType.OUT		: {
					// コマンドを追加する
					addCommand( new DoTweener( _target, {
						_color_ra	:1,
						_color_rb	:0,
						_color_ga	:1,
						_color_gb	:0,
						_color_ba	:1,
						_color_bb	:0,
						_color_aa	:1,
						_color_ab	:0,
						time		:0
					} ) );
					
					// コマンドを追加する
					addCommand( new DoTweener( _target, {
						_color_ra	:redMultiplier,
						_color_rb	:redOffset,
						_color_ga	:greenMultiplier,
						_color_gb	:greenOffset,
						_color_ba	:blueMultiplier,
						_color_bb	:blueOffset,
						_color_aa	:alphaMultiplier,
						_color_ab	:alphaOffset,
						time		:duration / 1000,
						transition	:Equations.easeNone
					} ) );
					break;
				}
			}
		}
	}
}





