﻿/*======================================================================*//**
* 
* Progression Framework
* 
* @author	Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* @version	2.0.6
* @see		http://progression.jp/
* @see		http://progression.libspark.org/
* 
* Project Manager
* taka:nium		http://nium.jp/
* 
* Hosted by
* Spark project	http://www.libspark.org/
* 
* Supported by
* yossy			http://www.be-interactive.org/
* cellfusion	http://cellfusion.jp/
* rch850		http://850mb.net/
* nobu			http://humming.via-kitchen.com/
* trick7		http://www.trick7.com/
* minaco		http://minaco.net/
* ksakai		http://www.onflow.jp/blog/
* 
* Licensed under the MIT License
* 
* Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
* 
*/
package jp.progression.core.components.commands {
	import jp.progression.casts.CastSprite;
	import jp.progression.Progression;
	import jp.progression.scenes.SceneId;
	
	/*======================================================================*//**
	* 
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @example <listing version="3.0" >
	* </listing>
	*/
	public class GotoCommandComponent extends CastSprite {
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="移動先のシーンパス", defaultValue="" )]
		public function get scenePath() 			:String { return _scenePath; }
		public function set scenePath( value		:String ):void {
			if ( !SceneId.validate( value ) ) { return; }
			
			// 値を設定する
			_scenePath = value;
			
			// 移動する
			Progression.goto( new SceneId( value ) );
		}
		private var _scenePath						:String = "";
		
		
		
		
		
		/*======================================================================*//**
		* 新しい GotoCommandComponent インスタンスを作成します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function GotoCommandComponent() {
			// 表示を削除する
			setProperties( {
				x			:0,
				y			:0,
				width		:0,
				height		:0,
				visible		:false
			} );
		}
		
		
		
		
		
		/*======================================================================*//**
		* 指定されたオブジェクトのストリング表現を返します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @return	オブジェクトのストリング表現です。
		*/
		public override function toString():String {
			return "[object GotoCommandComponent : " + ( parent ? parent.name : "null" ) + "]";
		}
	}
}





