﻿/*======================================================================*//**
* 
* Progression Framework
* 
* @author		Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* @version		2.0.22
* @see			http://progression.jp/
* @see			http://progression.libspark.org/
* 
* Project Manager
* taka:nium		http://nium.jp/
* 
* Hosted by
* Spark project	http://www.libspark.org/
* 
* Supported by
* yossy			http://www.be-interactive.org/
* cellfusion	http://cellfusion.jp/
* rch850		http://850mb.net/
* nobu			http://humming.via-kitchen.com/
* trick7		http://www.trick7.com/
* minaco		http://minaco.net/
* ksakai		http://www.onflow.jp/blog/
* 
* Licensed under the MIT License
* 
* Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
* 
*/
package jp.progression.core.components.loader {
	import flash.net.URLRequest;
	import jp.nium.utils.MovieClipUtil;
	import jp.progression.loader.EasyCastingLoader;
	import jp.progression.Progression;
	
	/*======================================================================*//**
	* 
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @example <listing version="3.0" >
	* </listing>
	*/
	public class EasyCastingLoaderComponent extends EasyCastingLoader {
		
		/*======================================================================*//**
		* @inheritDoc
		* @langversion 3.0
		* @playerversion Flash 9.0.28.0
		*/
		[Inspectable( name="URL", defaultValue="*.xml" )]
		public override function get url()						:String { return super.url; }
		public override function set url( value					:String ):void { super.url = value; }
		
		/*======================================================================*//**
		* @inheritDoc
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="デバッグ出力", defaultValue="false", verbose="1" )]
		public function get verbose()							:Boolean { return Progression.verbose.enabled; }
		public function set verbose( value						:Boolean ):void { Progression.verbose.enabled = value; }
		
		/*======================================================================*//**
		* @inheritDoc
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="シーン移動の自動ロック", defaultValue="true", verbose="1" )]
		public override function get autoLock()					:Boolean { return super.autoLock; }
		public override function set autoLock( value			:Boolean ):void { super.autoLock = value; }
		
		/*======================================================================*//**
		* @inheritDoc
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="ブラウザ同期", defaultValue="true" )]
		public override function get sync()						:Boolean { return super.sync; }
		public override function set sync( value				:Boolean ):void { super.sync = value; }
		
		/*======================================================================*//**
		* @inheritDoc
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="ロングパスの使用", defaultValue="true" )]
		public override function get useLongPath()				:Boolean { return super.useLongPath; }
		public override function set useLongPath( value			:Boolean ):void { super.useLongPath = value; }
		
		/*======================================================================*//**
		* @inheritDoc
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="キーボードショートカット", defaultValue="true", verbose="1" )]
		public override function get keyboardEmulate()			:Boolean { return super.keyboardEmulate; }
		public override function set keyboardEmulate( value		:Boolean ):void { super.keyboardEmulate = value; }
		
		
		
		
		
		/*======================================================================*//**
		* 新しい EasyCastingLoaderComponent インスタンスを作成します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function EasyCastingLoaderComponent() {
			// デバッグ設定を変更する
			Progression.verbose.filterCastObject = true;
			Progression.verbose.filterCommand = true;
			
			// 1 フレーム後に XML ファイルを読み込む
			MovieClipUtil.doLater( this, function():void {
				// 存在しなければ終了素する
				if ( !url ) { return; }
				
				load( new URLRequest( url ) );
			} );
		}
		
		
		
		
		
		/*======================================================================*//**
		* 指定されたオブジェクトのストリング表現を返します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @return	オブジェクトのストリング表現です。
		*/
		public override function toString():String {
			return "[object EasyCastingLoaderComponent : " + ( parent ? parent.name : "null" ) + "]";
		}
	}
}





