﻿/*======================================================================*//**
* 
* Progression Framework
* 
* @author		Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* @version		2.0.22
* @see			http://progression.jp/
* @see			http://progression.libspark.org/
* 
* Project Manager
* taka:nium		http://nium.jp/
* 
* Hosted by
* Spark project	http://www.libspark.org/
* 
* Supported by
* yossy			http://www.be-interactive.org/
* cellfusion	http://cellfusion.jp/
* rch850		http://850mb.net/
* nobu			http://humming.via-kitchen.com/
* trick7		http://www.trick7.com/
* minaco		http://minaco.net/
* ksakai		http://www.onflow.jp/blog/
* 
* Licensed under the MIT License
* 
* Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
* 
*/
package jp.progression.core.components.presets {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.ui.ContextMenu;
	import jp.nium.utils.ClassUtil;
	import jp.progression.casts.ICastObject;
	import jp.progression.casts.presets.RootButton;
	import jp.progression.core.commands.CommandList;
	import jp.progression.core.namespaces.progression_internal;
	import jp.progression.events.CastEvent;
	
	use namespace progression_internal;
	
	/*======================================================================*//**
	* 
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @example <listing version="3.0" >
	* </listing>
	*/
	public class RootButtonComponent extends RootButton {
		
		/*======================================================================*//**
		* @inheritDoc
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="Progression 識別子", defaultValue="" )]
		public override function get progressionId() 			:String { return super.progressionId; }
		public override function set progressionId( value		:String ):void { super.progressionId = value; }
		
		/*======================================================================*//**
		* @inheritDoc
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="対象ウィンドウ", defaultValue="_self" )]
		public override function get windowTarget() 			:String { return super.windowTarget; }
		public override function set windowTarget( value		:String ):void { super.windowTarget = value; }
		
		/*======================================================================*//**
		* @inheritDoc
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="アクセスキー", defaultValue="", verbose="1" )]
		public override function get accessKey() 				:String { return super.accessKey; }
		public override function set accessKey( value			:String ):void { super.accessKey = value; }
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="ツールチップの内容", defaultValue="" )]
		public function get toolTipText()						:String { return super.toolTip.text; }
		public function set toolTipText( value					:String ):void { super.toolTip.text = value; }
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="ツールチップ文字色", type="Color", defaultValue="#000000", verbose="1" )]
		public function get toolTipTextColor()					:uint { return super.toolTip.textColor; }
		public function set toolTipTextColor( value				:uint ):void { super.toolTip.textColor = value; }
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="ツールチップフォント", type="Font Name", defaultValue="_ゴシック", verbose="1" )]
		public function get toolTipFont()						:String { return super.toolTip.textFont; }
		public function set toolTipFont( value					:String ):void { super.toolTip.textFont = value; }
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="ツールチップ背景色", defaultValue="#FFFFFF", type="Color", verbose="1" )]
		public function get toolTipBackgroundColor()			:uint { return super.toolTip.backgroundColor; }
		public function set toolTipBackgroundColor( value		:uint ):void { super.toolTip.backgroundColor = value; }
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="ツールチップ線色", type="Color", defaultValue="#CCCCCC", verbose="1" )]
		public function get toolTipBorderColor()				:uint { return super.toolTip.borderColor; }
		public function set toolTipBorderColor( value			:uint ):void { super.toolTip.borderColor = value; }
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="ツールチップの遅延", type="Number", defaultValue="750", verbose="1" )]
		public function get toolTipDelay()						:int { return super.toolTip.delay; }
		public function set toolTipDelay( value					:int ):void { super.toolTip.delay = value; }
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="ツールチップの追従", type="Boolean", defaultValue="true", verbose="1" )]
		public function get toolTipFollowing()					:Boolean { return super.toolTip.following; }
		public function set toolTipFollowing( value				:Boolean ):void { super.toolTip.following = value; }
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="コンテクストメニュー", type="Boolean", defaultValue="true", verbose="1" )]
		public function get useContextMenu()					:Boolean { return _useContextMenu; }
		public function set useContextMenu( value				:Boolean ):void {
			_useContextMenu = value;
			
			// 対象が自分であれば
			if ( _target == this ) {
				uiContextMenu.enabled = value;
				return;
			}
			
			// 親が対象であれば
			if ( value ) {
				_target.contextMenu = progression_internal::contextMenu;
			}
			else {
				_target.contextMenu = new ContextMenu();
				_target.contextMenu.hideBuiltInItems();
			}
		}
		private var _useContextMenu								:Boolean = true;
		
		/*======================================================================*//**
		* @inheritDoc
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="up 点", defaultValue="over,up" )]
		public override function get upStateFrames()			:Array { return super.upStateFrames; }
		public override function set upStateFrames( value		:Array ):void { super.upStateFrames = value; }
		
		/*======================================================================*//**
		* @inheritDoc
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="over 点", defaultValue="up,over" )]
		public override function get overStateFrames()			:Array { return super.overStateFrames; }
		public override function set overStateFrames( value		:Array ):void { super.overStateFrames = value; }
		
		/*======================================================================*//**
		* @inheritDoc
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="down 点", defaultValue="down" )]
		public override function get downStateFrames()			:Array { return super.downStateFrames; }
		public override function set downStateFrames( value		:Array ):void { super.downStateFrames = value; }
		
		/*======================================================================*//**
		* @inheritDoc
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="current 点", defaultValue="current", verbose="1" )]
		public override function get currentStateFrame()		:* { return super.currentStateFrame; }
		public override function set currentStateFrame( value	:* ):void { super.currentStateFrame = value; }
		
		/*======================================================================*//**
		* @inheritDoc
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		[Inspectable( name="disable 点", defaultValue="disable", verbose="1" )]
		public override function get disableStateFrame()		:* { return super.disableStateFrame; }
		public override function set disableStateFrame( value	:* ):void { super.disableStateFrame = value; }
		
		
		
		
		
		/*======================================================================*//**
		* 新しい RootButtonComponent インスタンスを作成します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function RootButtonComponent() {
			// 初期化する
			upStateFrames = [ "over", "up" ];
			overStateFrames = [ "up", "over" ];
			downStateFrames = [ "over", "down" ];
			
			// 表示を削除する
			setProperties( {
				x			:0,
				y			:0,
				width		:0,
				height		:0
			} );
			
			// イベントリスナーを登録する
			addExclusivelyEventListener( Event.ADDED_TO_STAGE, _addedToStage, false, int.MAX_VALUE, true );
		}
		
		
		
		
		
		/*======================================================================*//**
		* 指定されたオブジェクトのストリング表現を返します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @return	オブジェクトのストリング表現です。
		*/
		public override function toString():String {
			return "[object RootButtonComponent : " + ( parent ? parent.name : "null" ) + "]";
		}
		
		
		
		
		
		/*======================================================================*//**
		* 
		*/
		private function _addedToStage( e:Event ):void {
			// ICastObject インターフェイスを実装していれば終了する
			if ( parent is ICastObject ) {
				trace( parent, "は、すでに ICastObject インターフェイスを実装している為、コンポーネントは無効化されます" );
				return;
			}
			
			// MovieClip クラスでなければ終了する
			if ( !( parent is MovieClip ) ) {
				trace( parent, "は、MovieClip クラスを継承していない為、コンポーネントは無効化されます" );
				return;
			}
			
			// dynamic クラスでなければ終了する
			if ( !ClassUtil.isDynamic( parent ) ) {
				trace( parent, "は、dynamic クラスではない為、コンポーネントは無効化されます" );
				return;
			}
			
			// ターゲットを親に設定する
			_target = MovieClip( parent );
			
			// ターゲットを初期化する
			_target.progression_internal_clearCommand = clearCommand;
			_target.progression_internal_getCommand = function():CommandList { return progression_internal::commandList; }
			_target.buttonMode = true;
			_target.mouseChildren = false;
			_target.useHandCursor = true;
			
			try {
				_target.gotoAndStop( upStateFrames[upStateFrames.length - 1] );
			}
			catch ( e:Error ) {
				_target.gotoAndStop( 1 );
			}
			
			// イベントリスナーを接続する
			_target.addEventListener( CastEvent.CAST_ADDED, dispatchEvent, false, int.MAX_VALUE, true );
			_target.addEventListener( CastEvent.CAST_REMOVED, dispatchEvent, false, int.MAX_VALUE, true );
			_target.addEventListener( MouseEvent.CLICK, progression_internal::click, false, int.MAX_VALUE, true );
			_target.addEventListener( MouseEvent.DOUBLE_CLICK, progression_internal::doubleClick, false, int.MAX_VALUE, true );
			_target.addEventListener( MouseEvent.MOUSE_DOWN, progression_internal::mouseDown, false, int.MAX_VALUE, true );
			_target.addEventListener( MouseEvent.MOUSE_UP, progression_internal::mouseUp, false, int.MAX_VALUE, true );
			_target.addEventListener( MouseEvent.MOUSE_OVER, progression_internal::mouseOver, false, int.MAX_VALUE, true );
			_target.addEventListener( MouseEvent.MOUSE_OUT, progression_internal::mouseOut, false, int.MAX_VALUE, true );
			_target.addEventListener( MouseEvent.MOUSE_WHEEL, progression_internal::mouseWheel, false, int.MAX_VALUE, true );
			_target.addEventListener( MouseEvent.ROLL_OVER, progression_internal::rollOver, false, int.MAX_VALUE, true );
			_target.addEventListener( MouseEvent.ROLL_OUT, progression_internal::rollOut, false, int.MAX_VALUE, true );
			
			// 初期化する
			useContextMenu = useContextMenu;
			uiContextMenu.progression_internal::mouseTarget = this;
		}
	}
}





