﻿/*======================================================================*//**
* 
* Progression Framework
* 
* @author		Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* @version		2.0.22
* @see			http://progression.jp/
* @see			http://progression.libspark.org/
* 
* Project Manager
* taka:nium		http://nium.jp/
* 
* Hosted by
* Spark project	http://www.libspark.org/
* 
* Supported by
* yossy			http://www.be-interactive.org/
* cellfusion	http://cellfusion.jp/
* rch850		http://850mb.net/
* nobu			http://humming.via-kitchen.com/
* trick7		http://www.trick7.com/
* minaco		http://minaco.net/
* ksakai		http://www.onflow.jp/blog/
* 
* Licensed under the MIT License
* 
* Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
* 
*/
package jp.progression.core.display {
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.filters.DropShadowFilter;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.utils.Timer;
	import jp.nium.display.IExDisplayObject;
	import jp.nium.events.EventIntegrator;
	import jp.nium.text.ExTextField;
	import jp.nium.utils.MathUtil;
	import jp.progression.casts.ICastObject;
	import jp.progression.events.CastMouseEvent;
	
	/*======================================================================*//**
	* 
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @example <listing version="3.0" >
	* </listing>
	*/
	public class ToolTip extends EventIntegrator {
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		private static var _currentTextField			:ExTextField;
		
		
		
		
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get target()					:IExDisplayObject { return _target; }
		private var _target								:IExDisplayObject;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get text()						:String { return _textField.text; }
		public function set text( value					:String ):void {
			// イベントリスナーを解除する
			if ( _target is ICastObject ) {
				ICastObject( _target ).completelyRemoveEventListener( CastMouseEvent.CAST_ROLL_OVER, _rollOver );
				ICastObject( _target ).completelyRemoveEventListener( CastMouseEvent.CAST_ROLL_OUT, _rollOut );
			}
			else {
				_target.completelyRemoveEventListener( MouseEvent.ROLL_OVER, _rollOver );
				_target.completelyRemoveEventListener( MouseEvent.ROLL_OUT, _rollOut );
			}
			
			// 文字列が不正なフォーマットであれば終了する
			if ( new RegExp( "^( |)$", "g" ).test( value ) ) { return; }
			
			// テキストを設定する
			_textField.text = value;
			
			// イベントリスナーを登録する
			if ( _target is ICastObject ) {
				ICastObject( _target ).addExclusivelyEventListener( CastMouseEvent.CAST_ROLL_OVER, _rollOver, false, int.MAX_VALUE, true );
			}
			else {
				_target.addExclusivelyEventListener( MouseEvent.ROLL_OVER, _rollOver, false, int.MAX_VALUE, true );
			}
		}
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get textColor()					:uint { return _textField.textColor; }
		public function set textColor( value			:uint ):void { _textField.textColor = MathUtil.range( value, 0x000000, 0xFFFFFF ); }
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get textFont()					:String { return _textField.getTextFormat().font; }
		public function set textFont( value				:String ):void {
			var fmt:TextFormat = _textField.getTextFormat();
			fmt.font = value;
			_textField.defaultTextFormat = fmt;
			_textField.setTextFormat( fmt );
		}
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get backgroundColor()			:uint { return _textField.backgroundColor; }
		public function set backgroundColor( value		:uint ):void { _textField.backgroundColor = MathUtil.range( value, 0x000000, 0xFFFFFF ); }
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get borderColor()				:uint { return _textField.borderColor; }
		public function set borderColor( value			:uint ):void { _textField.borderColor = MathUtil.range( value, 0x000000, 0xFFFFFF ); }
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get delay()						:int { return _delay; }
		public function set delay( value				:int ):void { _delay = value; }
		private var _delay								:int = 750;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get following()					:Boolean { return _following; }
		public function set following( value			:Boolean ):void { _following = value; }
		private var _following							:Boolean = true;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get marginX()					:Number { return _marginX; }
		public function set marginX( value				:Number ):void { _marginX = value; }
		private var _marginX							:Number = 5;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get marginY()					:Number { return _marginY; }
		public function set marginY( value				:Number ):void { _marginY = value; }
		private var _marginY							:Number = 20;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get friction()					:Number { return _friction; }
		public function set friction( value				:Number ):void { _friction = MathUtil.range( value, 0, 1 ); }
		private var _friction							:Number = 25 / 100;
		
		/*======================================================================*//**
		* ExTextField インスタンスを取得します。 
		*/
		private var _textField							:ExTextField;
		
		/*======================================================================*//**
		* Timer インスタンスを取得します。 
		*/
		private var _timer								:Timer;
		
		/*======================================================================*//**
		* Stage インスタンスを取得します。 
		*/
		private var _stage								:Stage;
		
		
		
		
		
		/*======================================================================*//**
		* 新しい ToolTip インスタンスを作成します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @throws	ArgumentError	ToolTip クラスを直接インスタンス化することはできません。
		*/
		public function ToolTip( target:IExDisplayObject ) {
			// 初期化する
			_target = target;
			_timer = new Timer( 1, 1 );
			
			// ExTextField　インスタンスを作成する
			_textField = new ExTextField();
			_textField.autoSize = TextFieldAutoSize.LEFT;
			_textField.background = true;
			_textField.backgroundColor = 0xFFFFFF;
			_textField.border = true;
			_textField.borderColor = 0xCCCCCC;
			_textField.defaultTextFormat = new TextFormat( "_ゴシック" );
			_textField.mouseEnabled = false;
			_textField.selectable = false;
			_textField.textColor = 0x000000;
			_textField.filters = [ new DropShadowFilter( 2, 45, 0x000000, 0.75, 4, 4 ) ];
		}
		
		
		
		
		
		/*======================================================================*//**
		* 
		*/
		private function _removeToolTip():void {
			if ( _stage && _stage.contains( _textField ) ) {
				// ツールチップを消去する
				_stage.removeChild( _textField );
				_currentTextField = null;
				
				// イベントリスナーを解除する
				_target.completelyRemoveEventListener( Event.ENTER_FRAME, _enterFrame );
			}
		}
		
		/*======================================================================*//**
		* 指定されたオブジェクトのストリング表現を返します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @return	オブジェクトのストリング表現です。
		*/
		public override function toString():String {
			return "[object ToolTip]";
		}
		
		
		
		
		
		/*======================================================================*//**
		* ユーザーが InteractiveObject インスタンスにポインティングデバイスを合わせたときに送出されます。
		*/
		private function _rollOver( e:MouseEvent ):void {
			// Stage の参照を保存する
			_stage = _target.stage;
			
			// Timer を初期化する
			_timer.reset();
			_timer.delay = delay;
			
			// イベントリスナーを登録する
			_timer.addEventListener( TimerEvent.TIMER_COMPLETE, _timerComplete, false, int.MAX_VALUE, true );
			if ( _target is ICastObject ) {
				ICastObject( _target ).addExclusivelyEventListener( CastMouseEvent.CAST_ROLL_OUT, _rollOut, false, int.MAX_VALUE, true );
			}
			else {
				_target.addExclusivelyEventListener( MouseEvent.ROLL_OUT, _rollOut, false, int.MAX_VALUE, true );
			}
			
			// Timer を開始する
			_timer.start();
		}
		
		/*======================================================================*//**
		* ユーザーが InteractiveObject インスタンスからポインティングデバイスを離したときに送出されます。
		*/
		private function _rollOut( e:MouseEvent ):void {
			// イベントリスナーを解除する
			_timer.removeEventListener( TimerEvent.TIMER_COMPLETE, _timerComplete );
			_target.completelyRemoveEventListener( Event.ENTER_FRAME, _enterFrame );
			if ( _target is ICastObject ) {
				ICastObject( _target ).completelyRemoveEventListener( CastMouseEvent.CAST_ROLL_OUT, _rollOut );
			}
			else {
				_target.completelyRemoveEventListener( MouseEvent.ROLL_OUT, _rollOut );
			}
			_stage.removeEventListener( MouseEvent.MOUSE_DOWN, _mouseDown );
			
			// ツールチップを削除する
			_removeToolTip();
		}
		
		/*======================================================================*//**
		* 
		*/
		private function _mouseMove( e:MouseEvent ):void {
			// イベントリスナーを解除する
			if ( _target is ICastObject ) {
				ICastObject( _target ).completelyRemoveEventListener( CastMouseEvent.CAST_MOUSE_MOVE, _mouseMove );
			}
			else {
				_target.completelyRemoveEventListener( MouseEvent.MOUSE_MOVE, _mouseMove );
			}
			
			// ツールチップを削除する
			_removeToolTip();
		}
		
		/*======================================================================*//**
		* 
		*/
		private function _mouseDown( e:MouseEvent ):void {
			// イベントリスナーを解除する
			_target.completelyRemoveEventListener( Event.ENTER_FRAME, _enterFrame );
			_stage.removeEventListener( MouseEvent.MOUSE_DOWN, _mouseDown );
			
			// ツールチップを削除する
			_removeToolTip();
		}
		
		/*======================================================================*//**
		* 
		*/
		private function _enterFrame( e:Event ):void {
			_textField.x += ( _stage.mouseX + marginX - _textField.x ) * friction;
			_textField.y += ( _stage.mouseY + marginY - _textField.y ) * friction;
		}
		
		/*======================================================================*//**
		* 
		*/
		private function _timerComplete( e:TimerEvent ):void {
			Timer( e.target ).removeEventListener( TimerEvent.TIMER_COMPLETE, _timerComplete );
			
			// 既存のツールチップが存在すれば削除する
			if ( _currentTextField ) {
				_stage.removeChild( _currentTextField );
			}
			
			// ツールチップを表示する
			_currentTextField = ExTextField( _stage.addChild( _textField ) );
			
			// 初期座標を設定する
			_textField.x = _stage.mouseX + marginX;
			_textField.y = _stage.mouseY + marginY;
			
			// 追従が有効であれば
			if ( _following ) {
				_target.addExclusivelyEventListener( Event.ENTER_FRAME, _enterFrame, false, int.MAX_VALUE, true );
				_stage.addEventListener( MouseEvent.MOUSE_DOWN, _mouseDown, false, int.MAX_VALUE, true );
			}
			else {
				if ( _target is ICastObject ) {
					ICastObject( _target ).addExclusivelyEventListener( CastMouseEvent.CAST_MOUSE_MOVE, _mouseMove, false, int.MAX_VALUE, true );
				}
				else {
					_target.addExclusivelyEventListener( MouseEvent.MOUSE_MOVE, _mouseMove, false, int.MAX_VALUE, true );
				}
			}
		}
	}
}





