﻿/*======================================================================*//**
* 
* Progression Framework
* 
* @author		Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* @version		2.0.22
* @see			http://progression.jp/
* @see			http://progression.libspark.org/
* 
* Project Manager
* taka:nium		http://nium.jp/
* 
* Hosted by
* Spark project	http://www.libspark.org/
* 
* Supported by
* yossy			http://www.be-interactive.org/
* cellfusion	http://cellfusion.jp/
* rch850		http://850mb.net/
* nobu			http://humming.via-kitchen.com/
* trick7		http://www.trick7.com/
* minaco		http://minaco.net/
* ksakai		http://www.onflow.jp/blog/
* 
* Licensed under the MIT License
* 
* Copyright (c) 2007-2008 taka:nium.jp, supported by Spark project.
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to enable, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE enable OR OTHER DEALINGS IN
* THE SOFTWARE.
* 
*/
package jp.progression.core.ui {
	import com.asual.swfaddress.SWFAddress;
	import flash.events.ContextMenuEvent;
	import flash.net.navigateToURL;
	import flash.net.URLRequest;
	import flash.system.System;
	import flash.ui.ContextMenu;
	import flash.ui.ContextMenuItem;
	import flash.utils.escapeMultiByte;
	import jp.nium.external.Browser;
	import jp.nium.lang.Locale;
	import jp.progression.core.managers.HistoryManager;
	import jp.progression.core.managers.PrintManager;
	import jp.progression.core.namespaces.progression_internal;
	
	use namespace progression_internal;
	
	/*======================================================================*//**
	* 
	* @langversion 3.0
	* @playerversion Flash 9.0.45.0
	* @example <listing version="3.0" >
	* </listing>
	*/
	public class CastObjectContextMenu {
		
		/*======================================================================*//**
		* @private
		*/
		private static var _internallyCalled		:Boolean = false;
		
		/*======================================================================*//**
		* @private
		*/
		private static var _locate							:Boolean = function():Boolean {
			Locale.setString( "前に戻る","ja", "前に戻る" );
			Locale.setString( "次に進む","ja", "次に進む" );
			Locale.setString( "更新","ja", "更新" );
			Locale.setString( "新規ウィンドウで開く","ja", "新規ウィンドウで開く" );
			Locale.setString( "URL をコピーする","ja", "URL をコピーする" );
			Locale.setString( "URL をメールで送信する","ja", "URL をメールで送信する" );
			Locale.setString( "印刷する","ja", "印刷する" );
			Locale.setString( "操作方法について by Progression","ja", "操作方法について by Progression" );
			
			Locale.setString( "前に戻る","en", "Back" );
			Locale.setString( "次に進む","en", "Forword" );
			Locale.setString( "更新","en", "Reload" );
			Locale.setString( "新規ウィンドウで開く","en", "Open Link in New Window" );
			Locale.setString( "URL をコピーする","en", "Copy Link Location" );
			Locale.setString( "URL をメールで送信する","en", "Send Link" );
			Locale.setString( "印刷する","en", "Print" );
			Locale.setString( "操作方法について by Progression","en", "Help by Progression" );
			
			return true;
		}.apply();
		
		
		
		
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get enabled()						:Boolean { return _enabled; }
		public function set enabled( value					:Boolean ):void { _enabled = value; }
		private var _enabled								:Boolean = true;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get customItems()					:Array { return _customItems; }
		public function set customItems( value				:Array ):void { _customItems = value; }
		private var _customItems							:Array;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get hideHistory()					:Boolean { return _hideHistory; }
		public function set hideHistory( value				:Boolean ):void { _hideHistory = value; }
		private var _hideHistory							:Boolean = false;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get hideReload()					:Boolean { return _hideReload; }
		public function set hideReload( value				:Boolean ):void { _hideReload = value; }
		private var _hideReload								:Boolean = false;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get hideOpenNewWindow()				:Boolean { return _hideOpenNewWindow; }
		public function set hideOpenNewWindow( value		:Boolean ):void { _hideOpenNewWindow = value; }
		private var _hideOpenNewWindow						:Boolean = false;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get hideCopyURL()					:Boolean { return _hideCopyURL; }
		public function set hideCopyURL( value				:Boolean ):void { _hideCopyURL = value; }
		private var _hideCopyURL							:Boolean = false;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get hidePrint()						:Boolean { return _hidePrint; }
		public function set hidePrint( value				:Boolean ):void { _hidePrint = value; }
		private var _hidePrint								:Boolean = false;
		
		/*======================================================================*//**
		* 
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		*/
		public function get hideBuiltInItems()				:Boolean { return _hideBuiltInItems; }
		public function set hideBuiltInItems( value			:Boolean ):void { _hideBuiltInItems = value; }
		private var _hideBuiltInItems						:Boolean = true;
		
		/*======================================================================*//**
		* 
		*/
		private var _target									:ContextMenu;
		
		
		
		
		
		/*======================================================================*//**
		* 新しい CastObjectContextMenu インスタンスを作成します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @param	target			関連付けたい ContextMenu インスタンスです。
		* @throws	ArgumentError	CastObjectContextMenu クラスを直接インスタンス化することはできません。
		*/
		public function CastObjectContextMenu( target:ContextMenu ) {
			// パッケージ外から呼び出されたらエラーを送出する
			if ( !_internallyCalled ) { throw new ArgumentError( "Error #2012: CastObjectContextMenu クラスを直接インスタンス化することはできません。" ); }
			
			// 初期化する
			_target = target;
			_customItems = new Array();
			_internallyCalled = false;
			
			// イベントリスナーを登録する
			_target.addEventListener( ContextMenuEvent.MENU_SELECT, _menuSelect, false, int.MAX_VALUE, true );
		}
		
		
		
		
		
		/*======================================================================*//**
		* @private
		*/
		progression_internal static function createInstance( target:ContextMenu ):CastObjectContextMenu {
			_internallyCalled = true;
			return new CastObjectContextMenu( target );
		}
		
		
		
		
		
		/*======================================================================*//**
		* 指定されたオブジェクトのストリング表現を返します。
		* @langversion 3.0
		* @playerversion Flash 9.0.45.0
		* @return	オブジェクトのストリング表現です。
		*/
		public function toString():String {
			return "[object CastObjectContextMenu]";
		}
		
		
		
		
		
		/*======================================================================*//**
		* ユーザーが最初にコンテキストメニューを生成したときに、コンテキストメニューの内容が表示される前に送出されます。
		*/
		private function _menuSelect( e:ContextMenuEvent ):void {
			var items:Array = _target.customItems;
			var item:ContextMenuItem;
			
			// ビルドインアイテムを非表示にする
			if ( hideBuiltInItems ) {
				_target.hideBuiltInItems();
			}
			
			// 無効化されていれば終了する
			if ( !enabled ) { return;  }
			
			// 履歴を有効化するかどうか
			if ( !hideHistory ) {
				item = new ContextMenuItem( Locale.getString( "前に戻る" ) + "　" );
				item.enabled = ( HistoryManager.enabled && HistoryManager.hasHistory( -1 ) );
				item.addEventListener( ContextMenuEvent.MENU_ITEM_SELECT, function( e:ContextMenuEvent ):void {
					HistoryManager.back();
				} );
				items.push( item );
				
				item = new ContextMenuItem( Locale.getString( "次に進む" ) + "　" );
				item.enabled = ( HistoryManager.enabled && HistoryManager.hasHistory( 1 ) );
				item.addEventListener( ContextMenuEvent.MENU_ITEM_SELECT, function( e:ContextMenuEvent ):void {
					HistoryManager.forward();
				} );
				items.push( item );
			}
			
			// 更新を有効化するかどうか
			if ( !hideReload ) {
				item = new ContextMenuItem( Locale.getString( "更新" ) + "　" );
				item.enabled = Browser.enabled;
				item.addEventListener( ContextMenuEvent.MENU_ITEM_SELECT, function( e:ContextMenuEvent ):void {
					Browser.reload();
				} );
				items.push( item );
			}
			
			// 新規ウィンドウで開くを有効化するかどうか
			if ( !hideOpenNewWindow ) {
				item = new ContextMenuItem( Locale.getString( "新規ウィンドウで開く" ) + "　", true );
				item.enabled = Browser.enabled;
				item.addEventListener( ContextMenuEvent.MENU_ITEM_SELECT, function( e:ContextMenuEvent ):void {
					navigateToURL( new URLRequest( Browser.url ), "_blank" );
				} );
				items.push( item );
			}
			
			// URL のコピーを有効化するかどうか
			if ( !hideCopyURL ) {
				item = new ContextMenuItem( Locale.getString( "URL をコピーする" ) + "　", true );
				item.enabled = Browser.enabled;
				item.addEventListener( ContextMenuEvent.MENU_ITEM_SELECT, function( e:ContextMenuEvent ):void {
					System.setClipboard( Browser.url );
				} );
				items.push( item );
				
				item = new ContextMenuItem( Locale.getString( "URL をメールで送信する" ) + "　" );
				item.enabled = Browser.enabled;
				item.addEventListener( ContextMenuEvent.MENU_ITEM_SELECT, function( e:ContextMenuEvent ):void {
					navigateToURL( new URLRequest( "mailto:?subject=" + escapeMultiByte( SWFAddress.getTitle() ) + "&body=" + escape( Browser.url ) ) );
				} );
				items.push( item );
			}
			
			// 印刷機能を有効化するかどうか
			if ( !hidePrint ) {
				item = new ContextMenuItem( Locale.getString( "印刷する" ) + "　", true );
				item.enabled = PrintManager.enabled;
				item.addEventListener( ContextMenuEvent.MENU_ITEM_SELECT, function( e:ContextMenuEvent ):void {
					PrintManager.print();
				} );
				items.push( item );
			}
			
			// 先頭の要素のセパレータを有効化する
			ContextMenuItem( items[0] ).separatorBefore = true;
			
			// カスタムメニューを追加する
			var l:int = customItems.length;
			for ( var i:int = 0; i < l; i++ ) {
				items.unshift( customItems[l - i - 1] );
			}
			
			/*
			if ( Progression.usage ) {
				item = new ContextMenuItem( Locale.getString( "操作方法について by Progression" ) + "　", true );
				item.addEventListener( ContextMenuEvent.MENU_ITEM_SELECT, function( e:ContextMenuEvent ):void {
					navigateToURL( new URLRequest( Progression.USAGE_WEBSITE ), "_blank" );
				} );
				items.push( item );
			}
			*/
		}
	}
}





