﻿package myproject.navi {
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.geom.Point;
	import jp.progression.casts.CastButton;;
	import jp.progression.casts.CastSprite;
	import jp.progression.commands.DoTweener;
	import flash.events.Event;
	import jp.progression.commands.Func;
	import jp.progression.commands.ParallelList;
	
	public class Navigation extends CastButton {
		
		public var button1:NaviButton1;
		public var button2:NaviButton2;
		public var button3:NaviButton3;
		public var navihitarea:CastButton;
		
		public function Navigation() {
			
			alpha = 0;
			
			button1 = new NaviButton1();
			this.addChildAt(button1 , 1);
			
			button2 = new NaviButton2();
			this.addChildAt(button2 , 2);
			
			button3 = new NaviButton3();
			this.addChildAt(button3 , 3);
			
			navihitarea = new CastButton();
			navihitarea.graphics.beginFill(0x0 , 0);
			navihitarea.graphics.drawRect( -50, -50, 100, 100);
			navihitarea.graphics.endFill();
			this.addChildAt(navihitarea , 0);
			
		}
		
		protected override function _onCastAdded():void {
			stage.addEventListener(Event.RESIZE , onStageResize);
			
			this.x = stage.stageWidth / 2;
			this.y = stage.stageHeight / 2;
			
			addCommand(
				new DoTweener( this, {
					alpha : 1 ,
					time : 2 ,
					transition : "easeoutquad"
				} )
			);
		}
		
		protected override function _onCastRemoved():void {
			trace("ggggggggg");
		}
		
		protected override function _onCastRollOver():void {
			
			addCommand(
				new ParallelList(0 , 
					new DoTweener( navihitarea, {
						scaleX : 3.5 ,
						time : 1 ,
						transition : "easeOutBack"
					} ),
					new DoTweener( button1, {
						x : -120 ,
						time : 1 ,
						transition : "easeOutBack"
					} ),
					new DoTweener( button2, {
						x : 0 ,
						time : 1 ,
						transition : "easeOutBack"
					} ),
					new DoTweener( button3, {
						x : 120 ,
						time : 1 ,
						transition : "easeOutBack"
					} ) ,
					new Func(this , button1._textAlphaAdd) ,
					new Func(this , button2._textAlphaAdd) ,
					new Func(this , button3._textAlphaAdd) 
				) 
				
			);
		}
		
		protected override function _onCastRollOut():void {

			addCommand(
				new Func(this , function () {
					var btn = this.getChildAt(3);
					this.setChildIndex(btn , 1);
				}) ,
				
				new ParallelList(0 , 
					new DoTweener( navihitarea, {
						scaleX : 1 ,
						time : 1 ,
						transition : "easeOutBack"
					} ),
					new DoTweener( button1, {
						x : 0 ,
						time : 1 ,
						transition : "easeOutBack"
					} ),
					new DoTweener( button2, {
						x : 0 ,
						time : 1 ,
						transition : "easeOutBack"
					} ),
					new DoTweener( button3, {
						x : 0 ,
						time : 1 ,
						transition : "easeOutBack"
					} ) ,
					new Func(this , button1._textAlphaDel) ,
					new Func(this , button2._textAlphaDel) ,
					new Func(this , button3._textAlphaDel) 
				) 
			);
		}
		
		private function onStageResize(e:Event) {
			this.x = stage.stageWidth / 2;
			this.y = stage.stageHeight / 2;
		}
	}
	
}